#pragma once

#include "IkAES.h"
#include "IkRSA.h"

class CNpCrypt
{
public:
	CNpCrypt(void);
	virtual ~CNpCrypt(void);
	
protected:
	int m_nEncType;

	CIkAES m_ikAES;

public:

	void Init(int nEncType, const BYTE * pAesCryptKey = NULL);
	int GetEncType() { return m_nEncType; }
	CIkAES & GetIkAES() { return m_ikAES; }

	int AesEncrypt(const BYTE * pSrc, int nSrcLen, BYTE * pOutBuffer);
	int AesDecrypt(const BYTE * pSrc, int nSrcLen, BYTE * pOutBuffer);
	
	int AesEncryptSizeGuess(int nSrcLen);
};


inline
int CNpCrypt::AesEncryptSizeGuess(int nSrcLen)
{
	if( m_nEncType < 4 )
	{
		if( nSrcLen <= 16 )
			return nSrcLen;
	}

	if( m_nEncType == 3 )
	{
		return (nSrcLen+1);
	}

    return m_ikAES.EncryptedSizeGuess( nSrcLen );
}

